package dk.miracle.stockquote;

import org.switchyard.Exchange;
import org.switchyard.Message;
import org.switchyard.component.common.label.EndpointLabel;
import org.switchyard.component.resteasy.composer.RESTEasyBindingData;
import org.switchyard.component.resteasy.composer.RESTEasyContextMapper;
import org.switchyard.component.resteasy.composer.RESTEasyMessageComposer;

import dk.miracle.stockquote.vo.StockInfo;

public class CustomComposer extends RESTEasyMessageComposer {

    /**
     * {@inheritDoc}
     */
    @Override
    public Message compose(RESTEasyBindingData source, Exchange exchange) throws Exception {
    	final Message message = super.compose(source, exchange);
        if (source.getOperationName().equals("setStockQuote") && (source.getParameters().length == 2)) {
            StockInfo stockInfo = new StockInfo().setSymbol((String)source.getParameters()[0]).setQuote((String)source.getParameters()[1]);
            message.setContent(stockInfo);
        }
        return message;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public RESTEasyBindingData decompose(Exchange exchange, RESTEasyBindingData target) throws Exception {
        Object content = exchange.getMessage().getContent();
        String opName = exchange.getContract().getProviderOperation().getName();
        if (opName.equals("getStockQuote") && (content == null || ((StockInfo)content).getQuote().contains("N/A"))) {
        	System.out.println("Damnit! 404");
                exchange.getContext().setProperty(RESTEasyContextMapper.HTTP_RESPONSE_STATUS, 404).addLabels(new String[]{EndpointLabel.HTTP.label()});
        } else {
        	System.out.println("Content: "+content);
        }
        return super.decompose(exchange, target);
    }

}
