package dk.miracle.stockquote;

import javax.inject.Named;

import org.switchyard.annotations.Validator;
import org.switchyard.validate.BaseValidator;
import org.switchyard.validate.ValidationResult;

import dk.miracle.stockquote.vo.StockInfo;

@Named("StockInfoValidator")
public class StockInfoValidator {

	@Validator
	public ValidationResult validaeStockInfo(StockInfo stockInfo) {
		if (stockInfo.getSymbol() == null || stockInfo.getSymbol().length() == 0) {
			return BaseValidator.invalidResult("Empty Stock Symbol not allowed!");
		}
		if ("FISH".equals(stockInfo.getSymbol())) {
			return BaseValidator.invalidResult("Please don't ask for fish stock!");
		}
		return BaseValidator.validResult();
	}
}
