package dk.miracle.stockquote.trans;

import java.io.StringReader;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.stream.StreamSource;

import org.switchyard.annotations.Transformer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public final class StockTransformer {

	@Transformer(to = "{http://www.webserviceX.NET/}GetQuote")
	public Element transformStringToGetQuote(String stockSymbol) {
		String element = "<GetQuote xmlns=\"http://www.webserviceX.NET/\"><symbol>" + stockSymbol + "</symbol></GetQuote>";
		return toElement(element);
	}

	@Transformer(from = "{http://www.webserviceX.NET/}GetQuoteResponse")
	public String transformGetQuoteResponseToString(Element element) {
		// TODO Auto-generated method stub
		return getElementValue(element, "GetQuoteResult");
	}

	private Element toElement(String string) {
		DOMResult dom = new DOMResult();

		try {
			TransformerFactory.newInstance().newTransformer().transform(new StreamSource(new StringReader(string)), dom);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return ((Document) dom.getNode()).getDocumentElement();
	}

	private String getElementValue(Element parent, String elementName) {
		String value = null;
		NodeList nodes = parent.getElementsByTagName(elementName);

		if (nodes.getLength() > 0) {
			value = nodes.item(0).getChildNodes().item(0).getNodeValue();
		}

		return value;
	}

}
